<#--创建数据库-->
<#-- 输入参数 -->
<#--USER 数据库用户名 -->
<#--PASSWORD 数据库用户密码 -->
<#--DATABASENAME 数据库名 -->
<#--DATABASEDIR 数据库存放路径-->

DECLARE
  V_CNT NUMBER(10);
BEGIN
  SELECT COUNT(1) INTO V_CNT FROM DBA_USERS WHERE username=upper('${USER}');
  IF V_CNT>0 THEN
    EXECUTE IMMEDIATE 'DROP USER ${USER} CASCADE';
  END IF;
  EXECUTE IMMEDIATE 'create user ${USER} identified by ${PASSWORD} default tablespace ${DATABASENAME}';
  EXECUTE IMMEDIATE 'grant dba,connect,resource,debug any procedure, debug connect session to ${USER}';
  EXECUTE IMMEDIATE 'alter user ${USER} quota unlimited on ${DATABASENAME}';
  EXECUTE IMMEDIATE 'grant create job to ${USER}';
END;